
/*  A Bison parser, made from grammar.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse pcap_parse
#define yylex pcap_lex
#define yyerror pcap_error
#define yylval pcap_lval
#define yychar pcap_char
#define yydebug pcap_debug
#define yynerrs pcap_nerrs
#define	DST	258
#define	SRC	259
#define	HOST	260
#define	GATEWAY	261
#define	NET	262
#define	PORT	263
#define	LESS	264
#define	GREATER	265
#define	PROTO	266
#define	BYTE	267
#define	ARP	268
#define	RARP	269
#define	IP	270
#define	TCP	271
#define	UDP	272
#define	ICMP	273
#define	DECNET	274
#define	LAT	275
#define	MOPRC	276
#define	MOPDL	277
#define	TK_BROADCAST	278
#define	TK_MULTICAST	279
#define	NUM	280
#define	INBOUND	281
#define	OUTBOUND	282
#define	LINK	283
#define	GEQ	284
#define	LEQ	285
#define	NEQ	286
#define	ID	287
#define	EID	288
#define	HID	289
#define	LSH	290
#define	RSH	291
#define	LEN	292
#define	OR	293
#define	AND	294
#define	UMINUS	295

#line 1 "grammar.y"

/*
 * Copyright (c) 1988, 1989, 1990, 1991, 1992, 1993, 1994
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
#ifndef lint
static char rcsid[] =
    "@(#) $Header: grammar.y,v 1.39 94/06/14 20:09:25 leres Exp $ (LBL)";
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>

#include <net/if.h>
#include <net/bpf.h>

#include <netinet/in.h>
#include <netinet/if_ether.h>

#include <stdio.h>
#include <pcap.h>
#include <pcap-namedb.h>

#include "gencode.h"

#define QSET(q, p, d, a) (q).proto = (p),\
			 (q).dir = (d),\
			 (q).addr = (a)

int n_errors = 0;

static struct qual qerr = { Q_UNDEF, Q_UNDEF, Q_UNDEF, Q_UNDEF };

static void
yyerror(char *msg)
{
	++n_errors;
	bpf_error(msg);
	/* NOTREACHED */
}

#ifndef YYBISON
pcap_parse()
{
	return (yyparse());
}
#endif


#line 69 "grammar.y"
typedef union {
	int i;
	u_long h;
	u_char *e;
	char *s;
	struct stmt *stmt;
	struct arth *a;
	struct {
		struct qual q;
		struct block *b;
	} blk;
	struct block *rblk;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		143
#define	YYFLAG		-32768
#define	YYNTBASE	56

#define YYTRANSLATE(x) ((unsigned)(x) <= 295 ? yytranslate[x] : 82)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    40,     2,     2,     2,     2,    42,     2,    49,
    48,    45,    43,     2,    44,     2,    46,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    55,     2,    52,
    51,    50,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    53,     2,    54,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    41,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    47
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     6,     8,    12,    16,    20,    24,    26,
    28,    30,    32,    36,    38,    40,    42,    45,    47,    49,
    51,    55,    59,    61,    63,    65,    68,    72,    75,    78,
    81,    84,    87,    91,    93,    97,   101,   103,   105,   106,
   108,   110,   114,   118,   122,   126,   128,   130,   132,   134,
   136,   138,   140,   142,   144,   146,   148,   150,   152,   154,
   156,   159,   162,   165,   168,   173,   175,   177,   179,   181,
   183,   185,   187,   189,   191,   193,   198,   205,   209,   213,
   217,   221,   225,   229,   233,   237,   240,   244,   246,   248,
   250,   252,   254,   256,   258
};

static const short yyrhs[] = {    57,
    58,     0,    57,     0,     0,    67,     0,    58,    59,    67,
     0,    58,    59,    61,     0,    58,    60,    67,     0,    58,
    60,    61,     0,    39,     0,    38,     0,    62,     0,    81,
     0,    64,    65,    48,     0,    32,     0,    34,     0,    33,
     0,    63,    61,     0,    40,     0,    49,     0,    62,     0,
    66,    59,    61,     0,    66,    60,    61,     0,    81,     0,
    65,     0,    69,     0,    63,    67,     0,    70,    71,    72,
     0,    70,    71,     0,    70,    72,     0,    70,    11,     0,
    70,    73,     0,    68,    61,     0,    64,    58,    48,     0,
    74,     0,    78,    76,    78,     0,    78,    77,    78,     0,
    75,     0,    74,     0,     0,     4,     0,     3,     0,     4,
    38,     3,     0,     3,    38,     4,     0,     4,    39,     3,
     0,     3,    39,     4,     0,     5,     0,     7,     0,     8,
     0,     6,     0,    28,     0,    15,     0,    13,     0,    14,
     0,    16,     0,    17,     0,    18,     0,    19,     0,    20,
     0,    22,     0,    21,     0,    70,    23,     0,    70,    24,
     0,     9,    25,     0,    10,    25,     0,    12,    25,    80,
    25,     0,    26,     0,    27,     0,    50,     0,    29,     0,
    51,     0,    30,     0,    52,     0,    31,     0,    81,     0,
    79,     0,    74,    53,    78,    54,     0,    74,    53,    78,
    55,    25,    54,     0,    78,    43,    78,     0,    78,    44,
    78,     0,    78,    45,    78,     0,    78,    46,    78,     0,
    78,    42,    78,     0,    78,    41,    78,     0,    78,    35,
    78,     0,    78,    36,    78,     0,    44,    78,     0,    64,
    79,    48,     0,    37,     0,    42,     0,    41,     0,    52,
     0,    50,     0,    51,     0,    25,     0,    64,    81,    48,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   117,   121,   123,   125,   126,   127,   128,   129,   131,   133,
   135,   136,   138,   140,   141,   157,   158,   160,   162,   164,
   165,   166,   168,   170,   172,   173,   175,   176,   177,   178,
   179,   181,   182,   183,   184,   186,   188,   191,   192,   195,
   196,   197,   198,   199,   200,   203,   204,   205,   208,   210,
   211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
   222,   223,   224,   225,   226,   227,   228,   230,   231,   232,
   234,   235,   236,   238,   239,   241,   242,   243,   244,   245,
   246,   247,   248,   249,   250,   251,   252,   253,   255,   256,
   257,   258,   259,   261,   262
};

static const char * const yytname[] = {   "$","error","$undefined.","DST","SRC",
"HOST","GATEWAY","NET","PORT","LESS","GREATER","PROTO","BYTE","ARP","RARP","IP",
"TCP","UDP","ICMP","DECNET","LAT","MOPRC","MOPDL","TK_BROADCAST","TK_MULTICAST",
"NUM","INBOUND","OUTBOUND","LINK","GEQ","LEQ","NEQ","ID","EID","HID","LSH","RSH",
"LEN","OR","AND","'!'","'|'","'&'","'+'","'-'","'*'","'/'","UMINUS","')'","'('",
"'>'","'='","'<'","'['","']'","':'","prog","null","expr","and","or","id","nid",
"not","paren","pid","qid","term","head","rterm","pqual","dqual","aqual","ndaqual",
"pname","other","relop","irelop","arth","narth","byteop","pnum",""
};
#endif

static const short yyr1[] = {     0,
    56,    56,    57,    58,    58,    58,    58,    58,    59,    60,
    61,    61,    61,    62,    62,    62,    62,    63,    64,    65,
    65,    65,    66,    66,    67,    67,    68,    68,    68,    68,
    68,    69,    69,    69,    69,    69,    69,    70,    70,    71,
    71,    71,    71,    71,    71,    72,    72,    72,    73,    74,
    74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
    75,    75,    75,    75,    75,    75,    75,    76,    76,    76,
    77,    77,    77,    78,    78,    79,    79,    79,    79,    79,
    79,    79,    79,    79,    79,    79,    79,    79,    80,    80,
    80,    80,    80,    81,    81
};

static const short yyr2[] = {     0,
     2,     1,     0,     1,     3,     3,     3,     3,     1,     1,
     1,     1,     3,     1,     1,     1,     2,     1,     1,     1,
     3,     3,     1,     1,     1,     2,     3,     2,     2,     2,
     2,     2,     3,     1,     3,     3,     1,     1,     0,     1,
     1,     3,     3,     3,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     2,     2,     2,     4,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     4,     6,     3,     3,     3,
     3,     3,     3,     3,     3,     2,     3,     1,     1,     1,
     1,     1,     1,     1,     3
};

static const short yydefact[] = {     3,
    39,     0,     0,     0,    52,    53,    51,    54,    55,    56,
    57,    58,    60,    59,    94,    66,    67,    50,    88,    18,
     0,    19,     1,    39,    39,     4,     0,    25,     0,    38,
    37,     0,    75,    74,    63,    64,     0,     0,     0,    86,
    10,     9,    39,    39,    26,     0,    75,    74,    14,    16,
    15,    32,    11,     0,     0,    12,    41,    40,    46,    49,
    47,    48,    30,    61,    62,    28,    29,    31,     0,    69,
    71,    73,     0,     0,     0,     0,     0,     0,     0,     0,
    68,    70,    72,     0,     0,    90,    89,    92,    93,    91,
     0,     0,     6,    39,    39,     5,    74,     8,     7,    33,
    87,    95,    17,    20,     0,    24,     0,    23,     0,     0,
     0,     0,    27,     0,    84,    85,    83,    82,    78,    79,
    80,    81,    35,    36,    65,    74,     0,    13,     0,     0,
    43,    45,    42,    44,    76,     0,    21,    22,     0,    77,
     0,     0,     0
};

static const short yydefgoto[] = {   141,
     1,    46,    43,    44,   103,    53,    54,    38,   106,   107,
    26,    27,    28,    29,    66,    67,    68,    39,    31,    84,
    85,    32,    33,    91,    34
};

static const short yypact[] = {-32768,
   121,   -19,   -14,    -7,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   234,-32768,     6,   197,   197,-32768,    34,-32768,   294,     2,
-32768,   244,-32768,-32768,-32768,-32768,   262,   234,     4,-32768,
-32768,-32768,   159,   159,-32768,   -31,    12,    21,-32768,-32768,
-32768,-32768,-32768,    34,    34,-32768,    26,    37,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    31,-32768,-32768,   234,-32768,
-32768,-32768,   234,   234,   234,   234,   234,   234,   234,   234,
-32768,-32768,-32768,   234,   234,-32768,-32768,-32768,-32768,-32768,
    48,   185,-32768,   159,   159,-32768,    10,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   -12,    29,     6,    21,    25,    80,
    92,    93,-32768,   109,   199,   199,    44,   222,    46,    46,
-32768,-32768,   185,   185,-32768,    24,    21,-32768,    34,    34,
-32768,-32768,-32768,-32768,-32768,    74,-32768,-32768,    47,-32768,
   100,   110,-32768
};

static const short yypgoto[] = {-32768,
-32768,   111,    15,    16,   -22,   -39,     3,    -1,-32768,-32768,
    -9,-32768,-32768,-32768,-32768,    45,-32768,     8,-32768,-32768,
-32768,    40,   -13,-32768,   -24
};


#define	YYLAST		318


static const short yytable[] = {    25,
    48,   -34,    56,    24,    52,    35,    41,    42,    30,   -12,
    36,    47,    15,    48,    45,   104,   100,    37,    97,    97,
    93,    98,    25,    25,    47,    55,    24,    24,   131,    56,
   108,    30,    30,    96,    99,    59,    22,    61,    62,   -34,
   -34,    95,    95,    41,    42,    94,    94,   -12,   -12,   -34,
    30,    30,    55,   105,    69,   104,    69,   -12,    15,   101,
    40,   -23,   -23,   109,   110,    49,    50,    51,   102,    97,
   126,   102,   125,    20,   111,   112,   128,    92,    73,    74,
   127,    47,    22,   132,    45,    76,    77,    78,    79,    80,
    79,    80,    95,    25,   133,   134,    94,    94,   139,   142,
   140,    30,    30,   105,    56,    56,   137,   138,   114,   143,
   113,    23,   115,   116,   117,   118,   119,   120,   121,   122,
    -2,   129,   130,   123,   124,     0,     0,    55,    55,     2,
     3,     0,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    73,    74,    15,    16,    17,    18,    75,
    76,    77,    78,    79,    80,     0,     0,    19,     0,     0,
    20,     0,   135,   136,    21,     0,     0,     2,     3,    22,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,     0,     0,    15,    16,    17,    18,     0,     0,     0,
    49,    50,    51,     0,     0,    19,     0,     0,    20,     0,
     0,     0,    21,     0,     0,     2,     3,    22,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    73,
    74,    15,    16,    17,    18,    75,    76,    77,    78,    79,
    80,     0,     0,    19,     0,     0,    20,     0,     0,     0,
    21,    77,    78,    79,    80,    22,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    73,    74,    15,     0,
     0,    18,     0,     0,    77,    78,    79,    80,     0,     0,
    19,     0,    70,    71,    72,     0,     0,    21,    73,    74,
     0,     0,    22,     0,    75,    76,    77,    78,    79,    80,
     0,     0,     0,    81,    82,    83,    57,    58,    59,    60,
    61,    62,    86,    87,    63,     0,     0,     0,     0,     0,
     0,    88,    89,    90,     0,     0,    64,    65
};

static const short yycheck[] = {     1,
    25,     0,    27,     1,    27,    25,    38,    39,     1,     0,
    25,    25,    25,    38,    24,    55,    48,    25,    43,    44,
    43,    44,    24,    25,    38,    27,    24,    25,     4,    54,
    55,    24,    25,    43,    44,     5,    49,     7,     8,    38,
    39,    43,    44,    38,    39,    43,    44,    38,    39,    48,
    43,    44,    54,    55,    53,    95,    53,    48,    25,    48,
    21,    38,    39,    38,    39,    32,    33,    34,    48,    94,
    95,    48,    25,    40,    38,    39,    48,    38,    35,    36,
   105,    95,    49,     4,    94,    42,    43,    44,    45,    46,
    45,    46,    94,    95,     3,     3,    94,    95,    25,     0,
    54,    94,    95,   105,   129,   130,   129,   130,    69,     0,
    66,     1,    73,    74,    75,    76,    77,    78,    79,    80,
     0,   107,   107,    84,    85,    -1,    -1,   129,   130,     9,
    10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    35,    36,    25,    26,    27,    28,    41,
    42,    43,    44,    45,    46,    -1,    -1,    37,    -1,    -1,
    40,    -1,    54,    55,    44,    -1,    -1,     9,    10,    49,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    25,    26,    27,    28,    -1,    -1,    -1,
    32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,
    -1,    -1,    44,    -1,    -1,     9,    10,    49,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    35,
    36,    25,    26,    27,    28,    41,    42,    43,    44,    45,
    46,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    -1,
    44,    43,    44,    45,    46,    49,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    35,    36,    25,    -1,
    -1,    28,    -1,    -1,    43,    44,    45,    46,    -1,    -1,
    37,    -1,    29,    30,    31,    -1,    -1,    44,    35,    36,
    -1,    -1,    49,    -1,    41,    42,    43,    44,    45,    46,
    -1,    -1,    -1,    50,    51,    52,     3,     4,     5,     6,
     7,     8,    41,    42,    11,    -1,    -1,    -1,    -1,    -1,
    -1,    50,    51,    52,    -1,    -1,    23,    24
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 118 "grammar.y"
{
	finish_parse(yyvsp[0].blk.b);
;
    break;}
case 3:
#line 123 "grammar.y"
{ yyval.blk.q = qerr; ;
    break;}
case 5:
#line 126 "grammar.y"
{ gen_and(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 6:
#line 127 "grammar.y"
{ gen_and(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 7:
#line 128 "grammar.y"
{ gen_or(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 8:
#line 129 "grammar.y"
{ gen_or(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 9:
#line 131 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; ;
    break;}
case 10:
#line 133 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; ;
    break;}
case 12:
#line 136 "grammar.y"
{ yyval.blk.b = gen_ncode((u_long)yyvsp[0].i,
						   yyval.blk.q = yyvsp[-1].blk.q); ;
    break;}
case 13:
#line 138 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; ;
    break;}
case 14:
#line 140 "grammar.y"
{ yyval.blk.b = gen_scode(yyvsp[0].s, yyval.blk.q = yyvsp[-1].blk.q); ;
    break;}
case 15:
#line 141 "grammar.y"
{
				  /* Decide how to parse HID based on proto */
				  yyval.blk.q = yyvsp[-1].blk.q;
				  switch (yyval.blk.q.proto) {
				  case Q_DECNET:
					yyval.blk.b =
					    gen_ncode(__pcap_atodn((char *)yyvsp[0].h),
					    yyval.blk.q);
					break;
				  default:
					yyval.blk.b =
					    gen_ncode(__pcap_atoin((char *)yyvsp[0].h),
					    yyval.blk.q);
					break;
				  }
				;
    break;}
case 16:
#line 157 "grammar.y"
{ yyval.blk.b = gen_ecode(yyvsp[0].e, yyval.blk.q = yyvsp[-1].blk.q); ;
    break;}
case 17:
#line 158 "grammar.y"
{ gen_not(yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 18:
#line 160 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; ;
    break;}
case 19:
#line 162 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; ;
    break;}
case 21:
#line 165 "grammar.y"
{ gen_and(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 22:
#line 166 "grammar.y"
{ gen_or(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 23:
#line 168 "grammar.y"
{ yyval.blk.b = gen_ncode((u_long)yyvsp[0].i,
						   yyval.blk.q = yyvsp[-1].blk.q); ;
    break;}
case 26:
#line 173 "grammar.y"
{ gen_not(yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; ;
    break;}
case 27:
#line 175 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i); ;
    break;}
case 28:
#line 176 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, yyvsp[0].i, Q_DEFAULT); ;
    break;}
case 29:
#line 177 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, Q_DEFAULT, yyvsp[0].i); ;
    break;}
case 30:
#line 178 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, Q_DEFAULT, Q_PROTO); ;
    break;}
case 31:
#line 179 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, Q_DEFAULT, yyvsp[0].i); ;
    break;}
case 32:
#line 181 "grammar.y"
{ yyval.blk = yyvsp[0].blk; ;
    break;}
case 33:
#line 182 "grammar.y"
{ yyval.blk.b = yyvsp[-1].blk.b; yyval.blk.q = yyvsp[-2].blk.q; ;
    break;}
case 34:
#line 183 "grammar.y"
{ yyval.blk.b = gen_proto_abbrev(yyvsp[0].i); yyval.blk.q = qerr; ;
    break;}
case 35:
#line 184 "grammar.y"
{ yyval.blk.b = gen_relation(yyvsp[-1].i, yyvsp[-2].a, yyvsp[0].a, 0);
				  yyval.blk.q = qerr; ;
    break;}
case 36:
#line 186 "grammar.y"
{ yyval.blk.b = gen_relation(yyvsp[-1].i, yyvsp[-2].a, yyvsp[0].a, 1);
				  yyval.blk.q = qerr; ;
    break;}
case 37:
#line 188 "grammar.y"
{ yyval.blk.b = yyvsp[0].rblk; yyval.blk.q = qerr; ;
    break;}
case 39:
#line 192 "grammar.y"
{ yyval.i = Q_DEFAULT; ;
    break;}
case 40:
#line 195 "grammar.y"
{ yyval.i = Q_SRC; ;
    break;}
case 41:
#line 196 "grammar.y"
{ yyval.i = Q_DST; ;
    break;}
case 42:
#line 197 "grammar.y"
{ yyval.i = Q_OR; ;
    break;}
case 43:
#line 198 "grammar.y"
{ yyval.i = Q_OR; ;
    break;}
case 44:
#line 199 "grammar.y"
{ yyval.i = Q_AND; ;
    break;}
case 45:
#line 200 "grammar.y"
{ yyval.i = Q_AND; ;
    break;}
case 46:
#line 203 "grammar.y"
{ yyval.i = Q_HOST; ;
    break;}
case 47:
#line 204 "grammar.y"
{ yyval.i = Q_NET; ;
    break;}
case 48:
#line 205 "grammar.y"
{ yyval.i = Q_PORT; ;
    break;}
case 49:
#line 208 "grammar.y"
{ yyval.i = Q_GATEWAY; ;
    break;}
case 50:
#line 210 "grammar.y"
{ yyval.i = Q_LINK; ;
    break;}
case 51:
#line 211 "grammar.y"
{ yyval.i = Q_IP; ;
    break;}
case 52:
#line 212 "grammar.y"
{ yyval.i = Q_ARP; ;
    break;}
case 53:
#line 213 "grammar.y"
{ yyval.i = Q_RARP; ;
    break;}
case 54:
#line 214 "grammar.y"
{ yyval.i = Q_TCP; ;
    break;}
case 55:
#line 215 "grammar.y"
{ yyval.i = Q_UDP; ;
    break;}
case 56:
#line 216 "grammar.y"
{ yyval.i = Q_ICMP; ;
    break;}
case 57:
#line 217 "grammar.y"
{ yyval.i = Q_DECNET; ;
    break;}
case 58:
#line 218 "grammar.y"
{ yyval.i = Q_LAT; ;
    break;}
case 59:
#line 219 "grammar.y"
{ yyval.i = Q_MOPDL; ;
    break;}
case 60:
#line 220 "grammar.y"
{ yyval.i = Q_MOPRC; ;
    break;}
case 61:
#line 222 "grammar.y"
{ yyval.rblk = gen_broadcast(yyvsp[-1].i); ;
    break;}
case 62:
#line 223 "grammar.y"
{ yyval.rblk = gen_multicast(yyvsp[-1].i); ;
    break;}
case 63:
#line 224 "grammar.y"
{ yyval.rblk = gen_less(yyvsp[0].i); ;
    break;}
case 64:
#line 225 "grammar.y"
{ yyval.rblk = gen_greater(yyvsp[0].i); ;
    break;}
case 65:
#line 226 "grammar.y"
{ yyval.rblk = gen_byteop(yyvsp[-1].i, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 66:
#line 227 "grammar.y"
{ yyval.rblk = gen_inbound(0); ;
    break;}
case 67:
#line 228 "grammar.y"
{ yyval.rblk = gen_inbound(1); ;
    break;}
case 68:
#line 230 "grammar.y"
{ yyval.i = BPF_JGT; ;
    break;}
case 69:
#line 231 "grammar.y"
{ yyval.i = BPF_JGE; ;
    break;}
case 70:
#line 232 "grammar.y"
{ yyval.i = BPF_JEQ; ;
    break;}
case 71:
#line 234 "grammar.y"
{ yyval.i = BPF_JGT; ;
    break;}
case 72:
#line 235 "grammar.y"
{ yyval.i = BPF_JGE; ;
    break;}
case 73:
#line 236 "grammar.y"
{ yyval.i = BPF_JEQ; ;
    break;}
case 74:
#line 238 "grammar.y"
{ yyval.a = gen_loadi(yyvsp[0].i); ;
    break;}
case 76:
#line 241 "grammar.y"
{ yyval.a = gen_load(yyvsp[-3].i, yyvsp[-1].a, 1); ;
    break;}
case 77:
#line 242 "grammar.y"
{ yyval.a = gen_load(yyvsp[-5].i, yyvsp[-3].a, yyvsp[-1].i); ;
    break;}
case 78:
#line 243 "grammar.y"
{ yyval.a = gen_arth(BPF_ADD, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 79:
#line 244 "grammar.y"
{ yyval.a = gen_arth(BPF_SUB, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 80:
#line 245 "grammar.y"
{ yyval.a = gen_arth(BPF_MUL, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 81:
#line 246 "grammar.y"
{ yyval.a = gen_arth(BPF_DIV, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 82:
#line 247 "grammar.y"
{ yyval.a = gen_arth(BPF_AND, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 83:
#line 248 "grammar.y"
{ yyval.a = gen_arth(BPF_OR, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 84:
#line 249 "grammar.y"
{ yyval.a = gen_arth(BPF_LSH, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 85:
#line 250 "grammar.y"
{ yyval.a = gen_arth(BPF_RSH, yyvsp[-2].a, yyvsp[0].a); ;
    break;}
case 86:
#line 251 "grammar.y"
{ yyval.a = gen_neg(yyvsp[0].a); ;
    break;}
case 87:
#line 252 "grammar.y"
{ yyval.a = yyvsp[-1].a; ;
    break;}
case 88:
#line 253 "grammar.y"
{ yyval.a = gen_loadlen(); ;
    break;}
case 89:
#line 255 "grammar.y"
{ yyval.i = '&'; ;
    break;}
case 90:
#line 256 "grammar.y"
{ yyval.i = '|'; ;
    break;}
case 91:
#line 257 "grammar.y"
{ yyval.i = '<'; ;
    break;}
case 92:
#line 258 "grammar.y"
{ yyval.i = '>'; ;
    break;}
case 93:
#line 259 "grammar.y"
{ yyval.i = '='; ;
    break;}
case 95:
#line 262 "grammar.y"
{ yyval.i = yyvsp[-1].i; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 264 "grammar.y"

